package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.RequisicionBoletoDAO;
import com.rjconsultores.ventaboletos.entidad.RequisicionBoleto;
import com.rjconsultores.ventaboletos.service.RequisicionBoletoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("requisicionBoletoService")
public class RequisicionBoletoServiceImpl implements RequisicionBoletoService {

	@Autowired
	private RequisicionBoletoDAO requisicionBoletoDAO;

	@Override
	public List<RequisicionBoleto> obtenerTodos() {
		return requisicionBoletoDAO.obtenerTodos();
	}

	@Override
	public RequisicionBoleto obtenerID(Integer id) {
		return requisicionBoletoDAO.obtenerID(id);
	}

	@Transactional
	public RequisicionBoleto suscribir(RequisicionBoleto entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return requisicionBoletoDAO.suscribir(entidad);
	}

	@Transactional
	public RequisicionBoleto actualizacion(RequisicionBoleto entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return requisicionBoletoDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(RequisicionBoleto entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		requisicionBoletoDAO.actualizacion(entidad);

	}

}
